const { app, BrowserWindow, dialog, ipcMain } = require('electron');
const { readFile, writeFile } = require('node:fs/promises');
const { } = require('node:os');
const path = require('node:path');

var filePath = null;

var win;

async function handleFileOpen(event, obj) {
        const { canceled, filePaths } = await dialog.showOpenDialog(win);
        var content;
        if (canceled) {
                filePath = null;
                content = '';
        } else {
                filePath = filePaths[0];
                content = await readFile(filePaths[0], 'utf-8');
        }

        return { filePath, content };
}

async function handleFileSave(event, content) {
        await writeFile(filePath, content);
}

async function createWindow() {
        win = new BrowserWindow({
                width: 800,
                height: 600,
                webPreferences: {
                        preload: path.join(__dirname, 'preload.js')
                }
        });

        win.loadFile('index.html');
        ipcMain.handle('open-file', handleFileOpen);
        ipcMain.handle('save-file', handleFileSave);
};

app.whenReady().then(() => {
        createWindow();
});